#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
/* struttura elementi della lista */

typedef struct nodo 
{
   
   int inf;
   struct nodo *pun;
}elemento;
/* prototipi delle funzioni */

elemento *crea_lista()
{
   
   elemento *p, *punt;
   int i, n;
   printf("\n Specificare il numero di elementi... ");
   scanf("%d", & n);
   if(n==0)
     {
	
	p = NULL; // lista vuota
	
     }
   else 
     {
	
	/* creazione primo elemento */
	p = (elemento *)malloc(sizeof(elemento));
	printf("\nInserisci il primo valore: ");
	scanf("%d", & p->inf);
	punt = p;
	/* creazione elementi successivi */
	for(i=2; i<=n; i++)
	  {
	     //attenzione all'ordine delle istruzioni
	     punt->pun = (elemento *)malloc(sizeof(elemento));
	     punt = punt->pun;
	     printf("\nInserisci il %d elemento: ", i);
	     scanf("%d", & punt->inf);
	  }
	// chiudo il for
	punt->pun = NULL; // marcatore fine lista
     } // chiudo l'if-else
   return(p);
} // chiudo la funzione


void visualizza_lista(elemento *p)
{
   
   printf("\nlista ---> ");
   
   /* ciclo di scansione */
   while(p != NULL)
     {
	
	printf("%d", p->inf); // visualizza l'informazione
	printf(" ---> ");
	p = p->pun; // scorre di un elemento
     }
   
   
   printf("NULL\n\n");
}

int trova_max_iter(elemento *p)
{
   int max=p->inf;
   while(p != NULL)
     {
	if(max < p->inf)
	  max = p->inf;
	p = p->pun; // scorre di un elemento
     }
   return max;
}

int trova_max_ric(elemento *p, int max)
{
   if(p == NULL)
     return max;
   if(p->inf > max)
     return trova_max_ric(p->pun, p->inf);
   else
     return trova_max_ric(p->pun, max);
}

int trova_max(elemento *p)
{
   return trova_max_ric(p, p->inf);
}


int main()
{
   
   elemento *lista; // puntatore della lista
   lista = crea_lista(); // crea la lista
   visualizza_lista(lista); // stampa la lista
   printf("Il massimo e' %d \n", trova_max_iter(lista));
   printf("Il massimo e' %d \n", trova_max(lista));
}
